#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum CompressionFormat {
    #[serde(rename = "GZIP")]
    Gzip,
    #[serde(rename = "ZIP")]
    Zip,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl CompressionFormat {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            CompressionFormat::Gzip => "GZIP",
            CompressionFormat::Zip => "ZIP",
            CompressionFormat::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for CompressionFormat {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for CompressionFormat {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for CompressionFormat {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<CompressionFormat, conjure_object::plain::ParseEnumError> {
        match v {
            "GZIP" => Ok(CompressionFormat::Gzip),
            "ZIP" => Ok(CompressionFormat::Zip),
            v => v.parse().map(|v| CompressionFormat::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for CompressionFormat {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<CompressionFormat, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the CompressionFormat enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
